Index: libabac/abac_pl_yy.c
===================================================================
--- libabac/abac_pl_yy.c	(revision 4f40c3e6cf53f7c95a2a544455682c85f601e846)
+++ libabac/abac_pl_yy.c	(revision 2e9455f11fea0205b8b4b1306b5d0804cda72e10)
@@ -1,2 +1,5 @@
+/**
+** abac_pl_yy.c 
+**/
 
 /* C declarations */
@@ -6,27 +9,22 @@
 #include <assert.h>
 
+#include "abac_stack.h"
+
+#include "abac_pl_yy.h"
 #include "abac_util.h"
-#include "abac_pl_yy.h"
+#include "abac_pl_gen.h"
+#include "abac_list.h"
+#include "abac_term.h"
+#include "abac_aspect.h"
 
 static int debug=0;
 
-int using_this=0;
-
-extern void panic(char*);
-
-/* from abac_pl_gen.c */
-extern abac_list_t *generate_pl_clauses(abac_aspect_t *, abac_aspect_t *);
-
-/* from rt2.y */
-extern void abac_yyinit();
-
-int abac_yy_error_code = 0; /* keeping last error code */
-
+abac_context_t *abac_context=NULL; /* context used for this parsing */
+static int yy_using_this=0;
+int abac_yy_error_code=0; /* keeping last error code */
 int abac_rule_is_oset=0;
-abac_list_t *abac_rule_clauses=NULL;
-abac_stack_t *abac_rule_id_clauses=NULL; /* tracking individual id credentials */
+
 abac_aspect_t *abac_rule_head_aspect=NULL;
 abac_aspect_t *abac_rule_tail_aspect=NULL;
-
 
 /* structure to hold the range information
@@ -84,4 +82,5 @@
    e_yy_DTERM_NAMED,     keyid:bob
    e_yy_DTERM_PRINCIPAL, principal:?P
+   e_yy_DTERM_THIS,      ?this 
    e_yy_DTERM_ANONYMOUS  ? */
 struct _abac_yy_term_t {
@@ -125,5 +124,8 @@
 };
 
+/* local */
 static void _free_yy_expression(abac_yy_expression_t *);
+abac_aspect_t *validate_head(int yytype, abac_yy_expression_t *expr);
+abac_aspect_t *validate_linked_tail(int yytype, abac_yy_expression_t *expr);
 
 /************************************************************************/
@@ -133,50 +135,4 @@
 }
 
-/************************************************************************/
-abac_stack_t *abac_yy_get_rule_id_clauses()
-{
-    return abac_rule_id_clauses;
-}
-
-abac_stack_t *abac_yy_init_rule_id_clauses()
-{
-    abac_rule_id_clauses=abac_stack_new();
-    return abac_rule_id_clauses;
-}
-
-void abac_yy_free_rule_id_clauses()
-{
-    if (abac_rule_id_clauses != NULL)
-        abac_stack_free(abac_rule_id_clauses);
-}
-
-void abac_yy_set_rule_clauses(abac_list_t *clauses)
-{
-    abac_rule_clauses=clauses;
-    if(debug) {
-         fprintf(stderr,"printing out abac_rule_clauses:\n");
-         abac_print_clauses(abac_rule_clauses,stderr);
-    }
-}
-
-abac_list_t *abac_yy_get_rule_clauses()
-{
-    return abac_rule_clauses;
-}
-
-void abac_yy_free_rule_clauses()
-{
-    if (abac_rule_clauses != NULL) {
-        abac_pl_free_id_certs();
-        abac_list_free(abac_rule_clauses);
-    }
-}
-
-/* just set it to NULL without freeing the structure */
-void abac_yy_reset_rule_clauses()
-{
-    abac_rule_clauses=NULL;
-}
-
 int abac_yy_get_rule_is_oset()
 {
@@ -193,5 +149,4 @@
     return abac_rule_tail_aspect;
 }
-
 
 /************************************************************************/
@@ -447,5 +402,10 @@
 static void _set_using_this()
 {
-    using_this=1;
+    yy_using_this=1;
+}
+
+int abac_yy_get_using_this()
+{
+    return yy_using_this;
 }
 
@@ -457,14 +417,5 @@
 void set_yy_term_principal_name(abac_yy_term_principal_t *ptr, char *name)
 {
-    /* handle special case when the name=this, change it to This */
-    if(strcmp(name,"this")==0) {
-       ptr->name=abac_xstrdup("This");
-       _set_using_this();
-       } else {
-         ptr->name=abac_xstrdup(name);
-         /* just in case name came in as This already */
-         if(strcasecmp(name,"this")==0) 
-           _set_using_this();
-    }
+    ptr->name=abac_xstrdup(name);
 }
 
@@ -503,4 +454,14 @@
         _free_yy_expression(ptr->cond_head_expr);
     free(ptr);
+}
+
+abac_yy_term_t *make_yy_term_dterm_this()
+{
+    abac_yy_term_t *ptr=(abac_yy_term_t*)abac_xmalloc(sizeof(abac_yy_term_t));
+    ptr->type = e_yy_DTERM_THIS;
+    ptr->next=NULL;
+    ptr->bcnt=1;
+    _set_using_this();
+    return ptr;
 }
 
@@ -615,4 +576,5 @@
             break;
         case e_yy_DTERM_ANONYMOUS:
+        case e_yy_DTERM_THIS:
             break;
     }
@@ -718,10 +680,13 @@
 void make_yy_oset_constraint(abac_yy_term_data_t *ptr, char *tail_string)
 {
-   abac_yy_expression_t *head_expr=get_yy_term_data_cond_head_expr(ptr);
-   if(head_expr) {
-       abac_aspect_t *head_aspect=validate_head(e_yy_OSET_TYPE,head_expr);
-       if(head_aspect != NULL) {
+   abac_yy_expression_t *cond_expr=get_yy_term_data_cond_head_expr(ptr);
+   if(cond_expr) {
+       abac_aspect_t *cond_aspect=NULL;
+       if(cond_expr->type == e_yy_EXPR_LINKED)
+           cond_aspect=validate_linked_tail(e_yy_OSET_TYPE,cond_expr);
+       else cond_aspect=validate_head(e_yy_OSET_TYPE,cond_expr);
+       if(cond_aspect != NULL) {
            if(debug) fprintf(stderr,"make_yy_oset_constraint..\n");
-           set_yy_term_data_cond_ptr(ptr,head_aspect);
+           set_yy_term_data_cond_ptr(ptr,cond_aspect);
        }
    }
@@ -731,10 +696,13 @@
 void make_yy_role_constraint(abac_yy_term_principal_t *ptr, char *tail_string)
 {
-   abac_yy_expression_t *head_expr=get_yy_term_principal_cond_head_expr(ptr);
-   if(head_expr) {
-       abac_aspect_t *head_aspect=validate_head(e_yy_ROLE_TYPE,head_expr);
-       if(head_aspect != NULL) {
+   abac_yy_expression_t *cond_expr=get_yy_term_principal_cond_head_expr(ptr);
+   if(cond_expr) {
+       abac_aspect_t *cond_aspect=NULL;
+       if(cond_expr->type == e_yy_EXPR_LINKED)
+           cond_aspect=validate_linked_tail(e_yy_ROLE_TYPE,cond_expr);
+       else cond_aspect=validate_head(e_yy_ROLE_TYPE,cond_expr);
+       if(cond_aspect != NULL) {
           if(debug) fprintf(stderr,"make_yy_role_constraint..\n");
-          set_yy_term_principal_cond_ptr(ptr,head_aspect);
+          set_yy_term_principal_cond_ptr(ptr,cond_aspect);
           set_yy_term_principal_isrange(ptr,0);
        }
@@ -798,4 +766,10 @@
               break;
            }
+           case e_yy_DTERM_THIS:
+           {
+              type=abac_verify_term_type("this");
+              name=abac_xstrdup("This");
+              break;
+           }
        }
        abac_term_t *param=NULL;
@@ -985,8 +959,7 @@
 
 /**********************************************************************/
-
-abac_list_t *make_oset_statement(abac_yy_expression_t *headexpr,
-                       abac_yy_expression_t *tailexpr) 
+int make_oset_statement(abac_yy_expression_t *headexpr, abac_yy_expression_t *tailexpr) 
 { 
+    int rc=0;
     abac_aspect_t *head_oset=NULL;
     abac_aspect_t *tail_oset=NULL;
@@ -994,6 +967,8 @@
 /* build up left side's abac oset structure */
     head_oset=validate_head(e_yy_OSET_TYPE, headexpr);
-    if(head_oset == NULL)
+    if(head_oset == NULL) {
+        rc=1;
         goto error;
+    }
 
 /* build up the right side's abac oset structure */
@@ -1016,6 +991,8 @@
                     break;
             }
-            if(curr_oset==NULL)
+            if(curr_oset==NULL) {
+                rc=1;
                 goto error;
+            }
 
             /* check if first one */
@@ -1031,13 +1008,4 @@
         } /* while */
 
-        preprocess_pl_head(head_oset);
-        preprocess_pl_tail(tail_oset);
-
-/* XXX collect up type clauses, constraint clauses and 
-   generate rule clauses */
-        abac_list_t *tmp=generate_pl_clauses(head_oset,tail_oset);
-        if(tmp == NULL)
-            goto error;
-
         if(debug) {
             fprintf(stderr,"aspect head_oset: ");
@@ -1049,4 +1017,5 @@
         }
 
+error:
         _free_yy_expression(headexpr);
         _free_yy_expression(tailexpr);
@@ -1054,14 +1023,5 @@
         abac_rule_tail_aspect=tail_oset;
         abac_rule_is_oset=1;
-        return tmp;
-
-error:
-        _free_yy_expression(headexpr);
-        _free_yy_expression(tailexpr);
-        if(head_oset)
-            abac_aspect_free(head_oset);
-        if(tail_oset)
-            abac_aspect_free(tail_oset);
-        return NULL;
+    return rc;
 }
 
@@ -1102,9 +1062,14 @@
 }
 /*****************************************************************************/
-/* build up the abac structure and also create the yap clause
-   and insert it into db */
-abac_list_t *make_role_statement(abac_yy_expression_t *headexpr,
-abac_yy_expression_t *tailexpr) 
+abac_context_t *get_abac_context()
+{
+    assert(abac_context);
+    return abac_context;
+}
+
+/* build up the abac structure */
+int make_role_statement(abac_yy_expression_t *headexpr, abac_yy_expression_t *tailexpr) 
 { 
+    int rc=0;
     abac_aspect_t *head_role=NULL;
     abac_aspect_t *tail_role=NULL;
@@ -1112,6 +1077,8 @@
 /* build up left side's abac role structure */
     head_role=validate_head(e_yy_ROLE_TYPE,headexpr);
-    if(head_role == NULL)
+    if(head_role == NULL) {
+        rc=1;
         goto error;
+    }
 
 /* build up the right side's abac role structure */
@@ -1131,6 +1098,8 @@
                     break;
             }
-            if(curr_role==NULL)
+            if(curr_role==NULL) {
+                rc=1;
                 goto error;
+            }
 
             /* check if first one */
@@ -1146,13 +1115,4 @@
         } /* while */
 
-        preprocess_pl_head(head_role);
-        preprocess_pl_tail(tail_role);
-
-/* collect up type clauses, constraint clauses and 
-   generate the final rule clauses */
-        abac_list_t *tmp=generate_pl_clauses(head_role,tail_role);
-        if(tmp == NULL)
-            goto error;
-
         if(debug) {
             fprintf(stderr,"aspect head_role: ");
@@ -1164,4 +1124,5 @@
         }
 
+error:
         _free_yy_expression(headexpr);
         _free_yy_expression(tailexpr);
@@ -1169,22 +1130,37 @@
         abac_rule_tail_aspect=tail_role;
         abac_rule_is_oset=0;
-        return tmp;
-
-error:
-        _free_yy_expression(headexpr);
-        _free_yy_expression(tailexpr);
-        if(head_role)
-            abac_aspect_free(head_role);
-        if(tail_role)
-            abac_aspect_free(tail_role);
-        return NULL;
+
+        return rc;
 }
 
 /************************************************************************/
-void abac_yy_init()
-{
+void abac_yy_init(abac_context_t *ctxt)
+{
+   yy_using_this=0;
+   abac_context=ctxt;
    abac_yyinit();
-   abac_yy_init_rule_id_clauses();
-}
-
-
+}
+
+/************************************************************************/
+/* this is called to parse a string into 2 aspect structures            */
+/* NEED TO BE LOCKED HERE XXX */
+int abac_yy_parse(abac_context_t *ctxt, char* attr_string, abac_aspect_t **head_aspect, abac_aspect_t **tail_aspect, int *using_this)
+{
+    /*ctxt could be null*/
+    abac_ll_reset_yyfptr(attr_string);
+    abac_yy_init(ctxt);
+    int rc=yyparse();
+    if (rc) {
+        free(attr_string);
+        abac_yy_set_error_code(ABAC_RT_CERT_INVALID);
+        return 1;
+    }
+    *head_aspect = abac_yy_get_rule_head_aspect();
+    *tail_aspect = abac_yy_get_rule_tail_aspect();
+    *using_this= abac_yy_get_using_this();
+    return 0;
+}
+
+
+
+
Index: libabac/abac_pl_yy.h
===================================================================
--- libabac/abac_pl_yy.h	(revision 4f40c3e6cf53f7c95a2a544455682c85f601e846)
+++ libabac/abac_pl_yy.h	(revision 2e9455f11fea0205b8b4b1306b5d0804cda72e10)
@@ -2,9 +2,9 @@
 #define __ABAC_PL_YY_H__
 
-/* C declarations */
-#include "abac_internal.h"
+#include "abac_defines.h"
 #include "abac_list.h"
-#include "abac_rt.h"
+#include "rt2_yy.h"
 
+/* from abac_pl_yy */
 typedef struct _abac_yy_principal_t abac_yy_principal_t;
 typedef struct _abac_yy_term_principal_t abac_yy_term_principal_t;
@@ -32,5 +32,6 @@
     e_yy_DTERM_NAMED=2,
     e_yy_DTERM_DATA=3,
-    e_yy_DTERM_ANONYMOUS=4
+    e_yy_DTERM_ANONYMOUS=4,
+    e_yy_DTERM_THIS=5
 };
 
@@ -41,5 +42,6 @@
 };
 
-abac_yy_expression_t *make_yy_expression(int type,void *pptr,
+/* exported */
+extern abac_yy_expression_t *make_yy_expression(int type,void *pptr,
               abac_yy_roleoset_t *optr, abac_yy_roleoset_t *linked_role);
 extern abac_list_t *make_yy_max_range(char *max);
@@ -56,4 +58,5 @@
 extern void set_yy_term_data_is_anonymous(abac_yy_term_data_t *ptr);
 extern abac_yy_term_t *make_yy_term_dterm_anonymous();
+extern abac_yy_term_t *make_yy_term_dterm_this();
 extern abac_yy_term_t *make_yy_term_dterm_data(abac_yy_term_data_t *dptr);
 extern abac_yy_term_t *make_yy_term_dterm_named(abac_yy_principal_t *nptr);
@@ -64,19 +67,17 @@
 extern abac_list_t *make_yy_val_range(char *val);
 
-extern abac_list_t *make_role_statement(abac_yy_expression_t *headexpr, abac_yy_expression_t *tailexpr);
-extern abac_list_t *make_oset_statement(abac_yy_expression_t *headexpr, abac_yy_expression_t *tailexpr);
-extern char *get_yy_term_data_name(abac_yy_term_data_t *ptr);
-extern abac_yy_term_data_t *get_yy_expression_object(abac_yy_expression_t *ptr);
-extern abac_yy_expression_t *add_yy_expression(abac_yy_expression_t *nexpr, abac_yy_expression_t *exprs);
 extern abac_yy_term_t *add_yy_term(abac_yy_term_t *nterm, abac_yy_term_t *terms);
 extern abac_list_t *add_yy_val_range(abac_list_t *ptr, char * val);
+extern char *get_yy_term_data_name(abac_yy_term_data_t *ptr);
+extern abac_yy_expression_t *add_yy_expression(abac_yy_expression_t *nexpr,
+                                             abac_yy_expression_t *exprs);
 
-extern abac_aspect_t *validate_head(int yytype, abac_yy_expression_t *expr);
-extern abac_aspect_t *validate_named_tail(int yytype, abac_yy_expression_t *expr);
-extern abac_aspect_t *validate_object_tail(int yytype,abac_yy_expression_t *expr);
-extern abac_aspect_t *validate_some_tail(int yytype, abac_yy_expression_t *expr);
-extern abac_aspect_t *validate_linked_tail(int yytype, abac_yy_expression_t *expr);
 
-#define ABAC_YY_INVALID_HEAD        -1
+extern int make_role_statement(abac_yy_expression_t *headexpr, abac_yy_expression_t *tailexpr);
+extern int make_oset_statement(abac_yy_expression_t *headexpr, abac_yy_expression_t *tailexpr);
+
+extern abac_context_t *get_abac_context();
+extern void abac_yy_set_error_code(int v);
+extern int abac_yy_get_using_this();
 
 #endif /* __ABC_PL_YY_H__ */
Index: libabac/abac_set.c
===================================================================
--- libabac/abac_set.c	(revision 4f40c3e6cf53f7c95a2a544455682c85f601e846)
+++ libabac/abac_set.c	(revision 2e9455f11fea0205b8b4b1306b5d0804cda72e10)
@@ -1,8 +1,13 @@
+/**
+** abac_set.c
+**/
+
 #include <stdlib.h>
 
+#include "abac_util.h"
+#include "abac_list.h"
+#include "uthash.h"
+
 #include "abac_set.h"
-#include "abac_util.h"
-
-#include "uthash.h"
 
 typedef struct _abac_set_element_t {
@@ -16,4 +21,5 @@
 };
 
+/****************************************************************/
 /**
  * Create a new struct.
Index: libabac/abac_set.h
===================================================================
--- libabac/abac_set.h	(revision 4f40c3e6cf53f7c95a2a544455682c85f601e846)
+++ libabac/abac_set.h	(revision 2e9455f11fea0205b8b4b1306b5d0804cda72e10)
@@ -1,16 +1,9 @@
-#ifndef __SET_H__
-#define __SET_H__
-
-#include "abac_list.h"
+#ifndef __ABAC_SET_H__
+#define __ABAC_SET_H__
 
 typedef struct _abac_set_t abac_set_t;
 
-abac_set_t *abac_set_new(void);
-int abac_set_add(abac_set_t *set, char *value);
-int abac_set_contains(abac_set_t *set, char *value);
-abac_list_t *abac_set_elements(abac_set_t *set);
-int abac_set_size(abac_set_t *set);
-void abac_set_intersect(abac_set_t *l, abac_set_t *r);
-void abac_set_free(abac_set_t *set);
+/* exported */
+/* none at this point */
 
-#endif /* __SET_H__ */
+#endif /* __ABAC_SET_H__ */
Index: libabac/abac_stack.c
===================================================================
--- libabac/abac_stack.c	(revision 4f40c3e6cf53f7c95a2a544455682c85f601e846)
+++ libabac/abac_stack.c	(revision 2e9455f11fea0205b8b4b1306b5d0804cda72e10)
@@ -1,2 +1,6 @@
+/**
+** abac_stack.c
+**/
+
 #include <stdlib.h>
 
@@ -4,4 +8,15 @@
 #include "abac_util.h"
 
+struct _abac_stack_element_t {
+    void *ptr;
+    abac_stack_element_t *prev, *next;
+};
+
+struct _abac_stack_t {
+    abac_stack_element_t *elts;
+    int size;
+};
+
+/****************************************************************/
 abac_stack_t *abac_stack_new(void) {
     abac_stack_t *ret = abac_xmalloc(sizeof(abac_stack_t));
Index: libabac/abac_stack.h
===================================================================
--- libabac/abac_stack.h	(revision 4f40c3e6cf53f7c95a2a544455682c85f601e846)
+++ libabac/abac_stack.h	(revision 2e9455f11fea0205b8b4b1306b5d0804cda72e10)
@@ -1,4 +1,4 @@
-#ifndef __STACK_H__
-#define __STACK_H__
+#ifndef __ABAC_STACK_H__
+#define __ABAC_STACK_H__
 
 #include "utlist.h"
@@ -6,21 +6,4 @@
 typedef struct _abac_stack_t abac_stack_t;
 typedef struct _abac_stack_element_t abac_stack_element_t;
-
-struct _abac_stack_element_t {
-    void *ptr;
-    abac_stack_element_t *prev, *next;
-};
-
-struct _abac_stack_t {
-    abac_stack_element_t *elts;
-    int size;
-};
-
-abac_stack_t *abac_stack_new(void);
-void abac_stack_push(abac_stack_t *stack, void *elt);
-int abac_stack_unique_push(abac_stack_t *stack, void *elt);
-void *abac_stack_pop(abac_stack_t *stack);
-int abac_stack_size(abac_stack_t *stack);
-void abac_stack_free(abac_stack_t *stack);
 
 #define abac_stack_foreach(STACK, CURRENT, BODY) do {  \
@@ -32,3 +15,11 @@
 } while (0)
 
-#endif /* __STACK_H__ */
+/* exported */
+extern abac_stack_t *abac_stack_new(void);
+extern void abac_stack_push(abac_stack_t *stack, void *elt);
+extern int abac_stack_unique_push(abac_stack_t *stack, void *elt);
+extern void *abac_stack_pop(abac_stack_t *stack);
+extern int abac_stack_size(abac_stack_t *stack);
+extern void abac_stack_free(abac_stack_t *stack);
+
+#endif /* __ABAC_STACK_H__ */
Index: libabac/abac_term.c
===================================================================
--- libabac/abac_term.c	(revision 4f40c3e6cf53f7c95a2a544455682c85f601e846)
+++ libabac/abac_term.c	(revision 2e9455f11fea0205b8b4b1306b5d0804cda72e10)
@@ -1,5 +1,4 @@
 /***********************************************************
    abac_term.c
-
  dterm=data term of rt1
  term is a kind of dterm
@@ -12,14 +11,58 @@
 #include <time.h>
 
-#include "abac_internal.h"
 #include "abac_util.h"
+#include "abac_aspect.h"
+#include "abac_verifier.h"
+#include "abac_id.h"
+#include "abac_list.h"
 
 static int debug=0;
+
 extern char *strptime(const char *s, const char *format, struct tm *tm);
+extern int ABAC_IN_PROLOG;
+
+/* termname[dtermtype] */
+static const char *const _termname[] =
+{
+  "badterm",
+  "integer",
+  "urn",
+  "float",
+  "boolean",
+  "string",
+  "time" ,
+  "principal",
+  "anonymous",
+  "this"
+};
+static int _termname_cnt=9;
+
+typedef enum _condtype_t {
+    e_COND_ROLE = 1,
+    e_COND_OSET = 2,
+    e_COND_RANGE = 3
+} abac_condtype_t;
+
+/* condname[condtype] */
+static const char *const _condname[] =
+{
+  "badcondition",
+  "role",
+  "oset",
+  "range"
+};
+static int _condname_cnt=3;
+
+/* itemname[itemtype] */
+static const char *const _itemname[] =
+{
+  "baditem",
+  "min",
+  "max",
+  "target"
+};
+static int _itemname_cnt=3;
 
 /* itemtype is
-     e_ITEM_MIN=1,
-     e_ITEM_MAX=2,
-     e_ITEM_TARGET=3,
  [a..b], [a..], [..b], [a],[a,b],[many a]
 */
@@ -68,5 +111,5 @@
 };
 
-/******************************************************************/
+/****************************************************************/
 char *abac_condtype_string(int i)
 {
@@ -134,5 +177,5 @@
             case e_ITEM_TARGET:
                 if(val)
-                    asprintf(&val,"%s,%s",val,cur->val);
+                    asprintf(&val,"%s,%s",cur->val,val);
                 else val=abac_xstrdup(cur->val);
                 break;
@@ -181,4 +224,14 @@
 
 abac_item_t *abac_item_dup(abac_item_t *ptr)
+{
+     abac_item_t *nptr=
+             (abac_item_t *)abac_xmalloc(sizeof(abac_item_t));
+     nptr->itemtype=ptr->itemtype;
+     nptr->val=abac_xstrdup(ptr->val);
+     return nptr;
+}
+
+/* deep copy/same as dup */
+abac_item_t *abac_item_copy(abac_item_t *ptr)
 {
      abac_item_t *nptr=
@@ -288,5 +341,5 @@
 }
 
-/* make a copy */
+/* make a shallow copy */
 abac_condition_t *abac_condition_dup(abac_condition_t *ptr)
 {
@@ -308,4 +361,34 @@
          abac_list_foreach(ptr->range_list, cur,
            nitem=abac_item_dup(cur);
+           abac_list_add(nptr->range_list,nitem); 
+         );
+         } else {
+             nptr->range_list=NULL;
+     }
+     return nptr;
+}
+
+/* make a deep copy */
+abac_condition_t *abac_condition_copy(abac_condition_t *ptr)
+{
+     abac_condition_t *nptr=
+             (abac_condition_t *)abac_xmalloc(sizeof(abac_condition_t));
+     nptr->condtype=ptr->condtype;
+     nptr->vartype=ptr->vartype;
+     if(ptr->string) {
+         nptr->string=abac_xstrdup(ptr->string);
+     } else {
+         nptr->string=NULL;
+     }
+     if(ptr->of_aspect)
+         nptr->of_aspect=abac_aspect_copy(ptr->of_aspect);
+         else nptr->of_aspect=NULL;
+
+     if(ptr->range_list!=NULL) {
+         nptr->range_list=abac_list_new();
+         abac_item_t *cur;
+         abac_item_t *nitem;
+         abac_list_foreach(ptr->range_list, cur,
+           nitem=abac_item_copy(cur);
            abac_list_add(nptr->range_list,nitem); 
          );
@@ -452,27 +535,4 @@
 }
 
-void abac_condition_dump(abac_condition_t *ptr, char *offset)
-{
-   printf("...constraint...\n");
-   printf("%s condtype: %d(%s)\n",
-                offset, ptr->condtype,abac_condtype_string(ptr->condtype));
-   printf("%s vartype: %d(%s)\n",
-                offset, ptr->vartype,abac_termtype_string(ptr->vartype));
-   if(ptr->string)
-       printf("%s string: %s\n", offset, ptr->string);
-       else printf("%s string: --\n", offset);
-   if(ptr->range_list)
-       printf("%s range_list: %s\n",
-                     offset, abac_range_string(ptr->range_list));
-       else printf("%s range_list: --\n", offset);
-   if(ptr->of_aspect) {
-       char *tmp=NULL;
-       asprintf(&tmp,"  %s",offset);
-       abac_aspect_dump(ptr->of_aspect,tmp);
-       free(tmp);
-       } else printf("%s of_aspect: --\n", offset);
-   printf("................\n");
-}
-
 /******************************************************************/
 int abac_term_isvar(abac_term_t *term)
@@ -521,4 +581,10 @@
 {
     if(ptr->type == e_TERM_ANONYMOUS)
+        return 1;
+    return 0;
+}
+int abac_term_is_this(abac_term_t *ptr)
+{
+    if(ptr->type == e_TERM_THIS)
         return 1;
     return 0;
@@ -607,5 +673,5 @@
     strptime(string, "%Y%m%dT%H%M%S", &tm1);
     strftime(buf, sizeof(buf), "time(%Y,%m,%d,%H,%M,%S)", &tm1);
-    return strdup(buf);
+    return abac_xstrdup(buf);
 }
 
@@ -617,7 +683,18 @@
     char* rt=strptime(string, "time(%Y,%m,%d,%H,%M,%S)", &tm1);
     if(rt==NULL)
-        return strdup(string);
+        return abac_xstrdup(string);
     strftime(buf, sizeof(buf), "%Y%m%dT%H%M%S", &tm1);
     return strdup(buf);
+}
+
+static abac_term_t *_abac_term_init()
+{
+    abac_term_t *ptr=abac_xmalloc(sizeof(abac_term_t));
+    ptr->type;
+    ptr->name=NULL;
+    ptr->isnamed=0;
+    ptr->p_name=NULL;
+    ptr->cn=NULL;
+    ptr->constraint=NULL;
 }
 
@@ -652,8 +729,7 @@
          }
      }
-     abac_term_t *ptr=abac_xmalloc(sizeof(abac_term_t));
+     abac_term_t *ptr=_abac_term_init();
      ptr->isnamed=0;
      ptr->type=type;
-     ptr->p_name=NULL;
      /* reformat the term name if it is a time type */
      if((!constraint) && _abac_termtype_is_time_type(type) && isdigit(name[0])) {
@@ -664,5 +740,4 @@
      }
      ptr->constraint=constraint;
-     ptr->cn=NULL;
      return ptr;
 }
@@ -680,8 +755,7 @@
      }
 
-     abac_term_t *ptr=abac_xmalloc(sizeof(abac_term_t));
+     abac_term_t *ptr=_abac_term_init();
      ptr->isnamed=0;
      ptr->type=type;
-     ptr->p_name=NULL;
      /* reformat the term name if it is a time type */
      if((!cptr) && _abac_termtype_is_time_type(type) && isdigit(name[0])) {
@@ -691,6 +765,6 @@
              ptr->name=abac_xstrdup(name);
      }
-     ptr->constraint=(cptr==NULL)?NULL:abac_condition_dup(cptr);
-     ptr->cn=NULL;
+     if(cptr)
+          ptr->constraint=abac_condition_dup(cptr);
      return ptr;
 }
@@ -699,40 +773,49 @@
 abac_term_t *abac_term_named_new(int idtype, char *name)
 {
-     if(debug) {
-         fprintf(stderr,"abac_term_named_new: \n");
-         fprintf(stderr,"  type is %d(%s)\n", idtype, abac_idtype_string(idtype));
-         fprintf(stderr,"  name is (%s)\n", name);
-     }
-     abac_term_t *ptr=abac_xmalloc(sizeof(abac_term_t));
+     DEBUG_PRINTF("abac_term_named_new: \n  type is %d(%s)\n", 
+                              idtype, abac_idtype_string(idtype));
+     DEBUG_PRINTF("  name is (%s)\n", name);
+     abac_term_t *ptr=_abac_term_init();
      ptr->isnamed=1;
      ptr->type=idtype;
      ptr->name=abac_xstrdup(name);
-     ptr->p_name=NULL;
      /* if ABAC_CN, no need to attach p */
      if(!USE("ABAC_CN"))
          asprintf(&ptr->p_name,"p%s",name);
-     ptr->constraint=NULL;
-     ptr->cn=NULL;
      return ptr;
 }
 
-/* seems to be always idtype==e_TERM_PRINCIPAL */
+abac_term_t *abac_term_this_create()
+{
+     DEBUG_PRINTF("abac_term_this_create:\n");
+     abac_term_t *ptr=_abac_term_init();
+     ptr->type=e_TERM_THIS;
+     ptr->name=abac_xstrdup("This");
+     return ptr;
+}
+
+
+/* seems to be always idtype==e_TERM_PRINCIPAL except for ?This*/
 abac_term_t *abac_term_named_create(char *name)
 {
-     if(debug) {
-         fprintf(stderr,"abac_term_named_create: \n");
-         fprintf(stderr,"  name is (%s)\n", name);
-     }
-
-     abac_term_t *ptr=abac_xmalloc(sizeof(abac_term_t));
+     DEBUG_PRINTF("abac_term_named_create: name is (%s)\n",name);
+     abac_term_t *ptr=_abac_term_init();
+     /* special case when it is a ?this */
+     if(strcasecmp(name,"this")==0) {
+        ptr->type=e_TERM_THIS;
+        ptr->name=abac_xstrdup("This");
+        return ptr;
+     }  
+     if(strcasecmp(name,"anonymous")==0) {
+        ptr->type=e_TERM_ANONYMOUS;
+        ptr->name=abac_xstrdup("_");
+        return ptr;
+     }  
      ptr->isnamed=1;
      ptr->type=e_TERM_PRINCIPAL;
      ptr->name=abac_xstrdup(name);
-     ptr->p_name=NULL;
      /* if ABAC_CN, no need to attach p */
      if(!USE("ABAC_CN"))
          asprintf(&ptr->p_name,"p%s",name);
-     ptr->constraint=NULL;
-     ptr->cn=NULL;
      return ptr;
 }
@@ -741,19 +824,12 @@
 abac_term_t *abac_term_id_create(abac_id_t *idptr)
 {
-     if(debug) {
-         fprintf(stderr,"abac_term_id_create: \n");
-         fprintf(stderr,"  name is (%s)\n", abac_id_name(idptr));
-     }
-
-     abac_term_t *ptr=abac_xmalloc(sizeof(abac_term_t));
+     DEBUG_PRINTF("abac_term_named_id_create: name is (%s)\n", abac_id_name(idptr));
+     abac_term_t *ptr=_abac_term_init();
      ptr->isnamed=1;
      ptr->type=abac_id_idtype(idptr);
      ptr->name=abac_xstrdup(abac_id_name(idptr));
-     ptr->p_name=NULL;
      /* if ABAC_CN, no need to attach p */
      if(!USE("ABAC_CN"))
          asprintf(&ptr->p_name,"p%s",ptr->name);
-     ptr->constraint=NULL;
-     ptr->cn=NULL;
      return ptr;
 }
@@ -763,13 +839,31 @@
 {
      assert(ptr);
-     abac_term_t *nptr=abac_xmalloc(sizeof(abac_term_t));
+     abac_term_t *nptr=_abac_term_init();
      nptr->isnamed=ptr->isnamed;
      nptr->type=ptr->type;
      nptr->name=abac_xstrdup(ptr->name);
-     nptr->p_name=(ptr->p_name==NULL)?NULL:abac_xstrdup(ptr->p_name);
+     if(ptr->p_name)
+         nptr->p_name=abac_xstrdup(ptr->p_name);
      if(ptr->constraint!=NULL)
         nptr->constraint=abac_condition_dup(ptr->constraint);
-        else nptr->constraint=NULL;
-     nptr->cn=(ptr->cn)==NULL?NULL:abac_xstrdup(ptr->cn);
+     if(ptr->cn)
+        nptr->cn=abac_xstrdup(ptr->cn);
+     return nptr;
+}
+
+/* a deep copy */
+abac_term_t *abac_term_copy(abac_term_t *ptr)
+{
+     if(ptr == NULL) return NULL;
+     abac_term_t *nptr=_abac_term_init();
+     nptr->isnamed=ptr->isnamed;
+     nptr->type=ptr->type;
+     if(ptr->name)
+         nptr->name=abac_xstrdup(ptr->name);
+     if(ptr->p_name)
+         nptr->p_name=abac_xstrdup(ptr->p_name);
+     if(ptr->constraint!=NULL)
+        nptr->constraint=abac_condition_copy(ptr->constraint);
+     if(ptr->cn)
         nptr->cn=abac_xstrdup(ptr->cn);
      return nptr;
@@ -838,5 +932,5 @@
     if(abac_term_is_time_type(ptr) && !ABAC_IN_PROLOG ) {
        name=abac_time_to_term(name); /* this should be freed */
-       if(debug) fprintf(stderr,"abac_term_typed_string_with_condition: trying to turn the time back\n");
+       DEBUG_PRINTF("abac_term_typed_string_with_condition: trying to turn the time back\n");
        free_name=1;
     }
@@ -849,11 +943,15 @@
            if(abac_term_is_anonymous(ptr)) {
                asprintf(&tmp,"[?]");
+           } else {
+               if(abac_term_is_this(ptr)) {
+                   asprintf(&tmp,"[?This]");
                } else {
                    if(isupper(name[0])) 
                        asprintf(&tmp,"[%s:?%s]", type, name);
                    else asprintf(&tmp,"[%s:%s]", type, name);
+               }
            }
     }
-    if(debug) fprintf(stderr,"abac_term_typed_string_with_condition: (%s)\n",tmp);
+    DEBUG_PRINTF("abac_term_typed_string_with_condition: (%s)\n",tmp);
     if(free_name) free(name);
     return tmp;
@@ -884,12 +982,16 @@
 }
 
-void abac_param_dump(abac_param_list_t *ptr, char *offset)
-{
-    printf("===params===\n");
+abac_param_list_t *abac_param_list_copy(abac_param_list_t *ptr)
+{
+    if(ptr == NULL) return NULL;
+    abac_param_list_t *nptr=abac_xmalloc(sizeof(abac_param_list_t));
+    nptr->list=abac_list_new();
     abac_term_t  *cur;
+    abac_term_t  *ncur;
     abac_list_foreach(ptr->list, cur,
-           abac_term_dump(cur, offset);
+        ncur=abac_term_copy(cur);
+        abac_list_add(nptr->list, ncur);
     );
-    printf("============\n");
+    return nptr;
 }
 
@@ -960,10 +1062,10 @@
                   final=NULL;
                   asprintf(&final,"%s,%s",tmp,s);
-                  if(debug) fprintf(stderr,"typed param so far, %s\n", final);
+                  DEBUG_PRINTF("typed param so far, %s\n", final);
                   free(tmp);
            }
            free(s);
     );
-    if(debug) fprintf(stderr,"typed param so far, %s\n", final);
+    DEBUG_PRINTF("typed param so far, %s\n", final);
     return final;
 }
@@ -988,10 +1090,10 @@
                   final=NULL;
                   asprintf(&final,"%s,%s",tmp,s);
-                  if(debug) fprintf(stderr,"param so far, %s\n", final);
+                  DEBUG_PRINTF("param so far, %s\n", final);
                   free(tmp);
            }
            free(s);
     );
-    if(debug) fprintf(stderr,"param so far, %s\n", final);
+    DEBUG_PRINTF("param so far, %s\n", final);
     return final;
 }
@@ -1034,23 +1136,2 @@
 }
 
-void abac_term_dump(abac_term_t *ptr, char *offset)
-{
-    printf("--- term---\n");
-    printf("%s type : %s\n",offset, abac_term_type_name(ptr));
-    printf("%s name : %s\n",offset, abac_term_name(ptr));
-    printf("%s isnamed: %d\n",offset,ptr->isnamed);
-    if(ptr->p_name)
-        printf("%s p_name: %s\n",offset,ptr->p_name);
-        else printf("%s p_name: --\n",offset);
-    if(ptr->cn)
-        printf("%s cn: %s\n",offset,ptr->cn);
-        else printf("%s cn: --\n",offset);
-    if(ptr->constraint) {
-        char *tmp=NULL;
-        asprintf(&tmp,"  %s", offset);
-        abac_condition_dump(ptr->constraint,offset);
-        free(tmp);
-        } else printf("%s constraint: --\n",offset);
-    printf("-----------\n");
-}
-
